]> gitweb.factorcode.org Git - factor.git/blob - build.sh
add xdg-state-dir
[factor.git] / build.sh
1 #!/usr/bin/env bash
2
3 # Programs returning != 0 will not cause script to exit
4 set +e
5
6 # Case insensitive string comparison
7 shopt -s nocaseglob
8 #shopt -s nocasematch
9
10 ECHO=echo
11 OS=
12 ARCH=
13 WORD=
14 GIT_PROTOCOL=${GIT_PROTOCOL:="git"}
15 GIT_URL=${GIT_URL:=$GIT_PROTOCOL"://github.com/factor/factor.git"}
16 SCRIPT_ARGS="$*"
17
18 REQUIRE_CLANG_VERSION=3.1
19
20 # return 1 on found
21 test_program_installed() {
22     if ! [[ -n $(type -p $1) ]] ; then
23         return 0;
24     fi
25     return 1;
26 }
27
28 # return 1 on found
29 test_programs_installed() {
30     local installed=0;
31     $ECHO -n "Checking for all($*)..."
32     for i in "$@" ;
33     do
34         test_program_installed $i
35         if [[ $? -eq 1 ]]; then
36             installed=$(( $installed + 1 ))
37         fi
38     done
39     if [[ $installed -eq $# ]] ; then
40         $ECHO "found!"
41         return 1
42     else
43         $ECHO "all not found."
44         return 0
45     fi
46 }
47
48 exit_script() {
49     if [[ $FIND_MAKE_TARGET = true ]] ; then
50         # Must be echo not $ECHO
51         echo $MAKE_TARGET;
52     fi
53     exit $1
54 }
55
56 ensure_program_installed() {
57     local installed=0;
58     $ECHO -n "Checking for any($*)..."
59     for i in "$@" ;
60     do
61         test_program_installed $i
62         if [[ $? -eq 1 ]]; then
63             $ECHO "found $i!"
64             installed=$(( $installed + 1 ))
65             return
66         fi
67     done
68     $ECHO "none found."
69     $ECHO -n "Install "
70     if [[ $# -eq 1 ]] ; then
71         $ECHO -n $1
72     else
73         $ECHO -n "any of [ $* ]"
74     fi
75     $ECHO " and try again."
76     if [[ $OS == macosx ]] ; then
77         $ECHO "If you have Xcode 4.3 or higher installed, you must install the"
78         $ECHO "Command Line Tools from Xcode Preferences > Downloads in order"
79         $ECHO "to build Factor."
80     fi
81     exit_script 1;
82 }
83
84 check_ret() {
85     # Can't execute any commands before saving $?
86     # $1 is the name of the command we are checking
87     RET=$?
88     if [[ $RET -ne 0 ]] ; then
89        $ECHO $1 failed
90        exit_script 2
91     fi
92 }
93
94 set_downloader() {
95     test_program_installed wget
96     if [[ $? -ne 0 ]] ; then
97         DOWNLOADER="wget -nd"
98         DOWNLOADER_NAME=wget
99         return
100     fi
101     test_program_installed curl
102     if [[ $? -ne 0 ]] ; then
103         DOWNLOADER="curl -L -f -O"
104         DOWNLOADER_NAME=curl
105         return
106     fi
107     $ECHO "error: wget or curl required"
108     exit_script 11
109 }
110
111 set_md5sum() {
112     test_program_installed md5sum
113     if [[ $? -ne 0 ]] ; then
114         MD5SUM=md5sum
115     else
116         MD5SUM="md5 -r"
117     fi
118 }
119
120 semver_into() {
121     RE_SEMVER="^([0-9]*)\.([0-9]*)\.([0-9]*)-?(.*)?$" # 3.3.3-5
122     CLANG_RE_OLD="^([0-9]*)\.([0-9]*)-?(.*)?$" # 3.3-5
123     if [[ $1 =~ $RE_SEMVER ]] ; then
124         export "$2=${BASH_REMATCH[1]}"
125         export "$3=${BASH_REMATCH[2]}"
126         export "$4=${BASH_REMATCH[3]}"
127         export "$5=${BASH_REMATCH[4]}"
128     elif [[ $1 =~ $CLANG_RE_OLD ]] ; then
129         export "$2=${BASH_REMATCH[1]}"
130         export "$3=${BASH_REMATCH[2]}"
131         export "$4=0"
132         export "$5=${BASH_REMATCH[3]}"
133     else
134         echo "unsupported version number, please report a bug: $1"
135         exit 123
136     fi
137 }
138
139 clang_version_ok() {
140     CLANG_VERSION=$(clang --version | head -n1)
141     CLANG_VERSION_RE='^[a-zA-Z0-9 ]* version (.*)$' # 3.3-5
142     if [[ $CLANG_VERSION =~ $CLANG_VERSION_RE ]] ; then
143         export "CLANG_VERSION=${BASH_REMATCH[1]}"
144         local CLANG_MAJOR CLANG_MINOR CLANG_PATCH CLANG_SPECIAL
145         semver_into "$CLANG_VERSION" CLANG_MAJOR CLANG_MINOR CLANG_PATCH CLANG_SPECIAL
146         if [[ $CLANG_MAJOR -lt 3
147             || ( $CLANG_MAJOR -eq 3 && $CLANG_MINOR -le 1 )
148             ]] ; then
149             echo "clang version required >= $REQUIRE_CLANG_VERSION, got $CLANG_VERSION"
150             return 1
151         fi
152     else
153         return 1
154     fi
155     return 0
156 }
157
158 set_cc() {
159     # on Cygwin we MUST use the MinGW "cross-compiler", therefore check these first
160     # furthermore, we prefer 64 bit over 32 bit versions if both are available
161
162     # we need this condition so we don't find a mingw32 compiler on linux
163     if [[ $OS == windows ]] ; then
164         test_programs_installed x86_64-w64-mingw32-gcc x86_64-w64-mingw32-g++
165         if [[ $? -ne 0 ]] ; then
166             [ -z "$CC" ] && CC=x86_64-w64-mingw32-gcc
167             [ -z "$CXX" ] && CXX=x86_64-w64-mingw32-g++
168             return
169         fi
170
171         test_programs_installed i686-w64-mingw32-gcc i686-w64-mingw32-g++
172         if [[ $? -ne 0 ]] ; then
173             [ -z "$CC" ] && CC=i686-w64-mingw32-gcc
174             [ -z "$CXX" ] && CXX=i686-w64-mingw32-g++
175             return
176         fi
177     fi
178
179     test_programs_installed clang clang++
180     if [[ $? -ne 0 ]] && clang_version_ok ; then
181         [ -z "$CC" ] && CC=clang
182         [ -z "$CXX" ] && CXX=clang++
183         return
184     fi
185
186     # gcc and g++ will fail to correctly build Factor on Cygwin
187     test_programs_installed gcc g++
188     if [[ $? -ne 0 ]] ; then
189         [ -z "$CC" ] && CC=gcc
190         [ -z "$CXX" ] && CXX=g++
191         return
192     fi
193
194     $ECHO "error: high enough version of either (clang/clang++) or (gcc/g++) required!"
195     exit_script 10
196 }
197
198 set_make() {
199     case $OS in
200         freebsd) MAKE=gmake ;;
201         *) MAKE=make ;;
202     esac
203     if [[ $MAKE = 'gmake' ]] ; then
204         ensure_program_installed gmake
205     fi
206 }
207
208 check_installed_programs() {
209     ensure_program_installed chmod
210     ensure_program_installed uname
211     ensure_program_installed git
212     ensure_program_installed wget curl
213     ensure_program_installed clang x86_64-w64-mingw32-gcc i686-w64-mingw32-gcc gcc
214     ensure_program_installed clang++ x86_64-w64-mingw32-g++ i686-w64-mingw32-g++ g++ cl
215     ensure_program_installed make gmake
216     ensure_program_installed md5sum md5
217     ensure_program_installed cut
218 }
219
220 check_library_exists() {
221     GCC_TEST=factor-library-test.c
222     GCC_OUT=factor-library-test.out
223     $ECHO -n "Checking for library $1..."
224     $ECHO "int main(){return 0;}" > $GCC_TEST
225     $CC $GCC_TEST -o $GCC_OUT -l $1 2>&-
226     if [[ $? -ne 0 ]] ; then
227         $ECHO "not found."
228     else
229         $ECHO "found."
230     fi
231     $DELETE -f $GCC_TEST
232     check_ret $DELETE
233     $DELETE -f $GCC_OUT
234     check_ret $DELETE
235 }
236
237 check_X11_libraries() {
238     check_library_exists GL
239     check_library_exists X11
240     check_library_exists pango-1.0
241 }
242
243 check_gtk_libraries() {
244     check_library_exists gobject-2.0
245     check_library_exists gtk-x11-2.0
246     check_library_exists gdk-x11-2.0
247     check_library_exists gdk_pixbuf-2.0
248     check_library_exists gtkglext-x11-1.0
249     check_library_exists atk-1.0
250     check_library_exists gio-2.0
251     check_library_exists gdkglext-x11-1.0
252     check_library_exists pango-1.0
253 }
254
255
256 check_libraries() {
257     case $OS in
258         linux) check_X11_libraries
259                check_gtk_libraries;;
260         unix) check_gtk_libraries;;
261     esac
262 }
263
264 check_factor_exists() {
265     if [[ -d "factor" ]] ; then
266         $ECHO "A directory called 'factor' already exists."
267         $ECHO "Rename or delete it and try again."
268         exit_script 4
269     fi
270 }
271
272 find_os() {
273     if [[ -n $OS ]] ; then return; fi
274     $ECHO "Finding OS..."
275     local uname_s=$(uname -s)
276     check_ret uname
277     case $uname_s in
278         CYGWIN_NT-5.2-WOW64) OS=windows;;
279         *CYGWIN_NT*) OS=windows;;
280         *CYGWIN*) OS=windows;;
281         MINGW32*) OS=windows;;
282         MINGW64*) OS=windows;;
283         MSYS_NT*) OS=windows;;
284         *darwin*) OS=macosx;;
285         *Darwin*) OS=macosx;;
286         *linux*) OS=linux;;
287         *Linux*) OS=linux;;
288         FreeBSD) OS=freebsd;;
289         Haiku) OS=haiku;;
290     esac
291 }
292
293 find_architecture() {
294     if [[ -n $ARCH ]] ; then return; fi
295     $ECHO "Finding ARCH..."
296     uname_m=$(uname -m)
297     check_ret uname
298     case $uname_m in
299        i386) ARCH=x86;;
300        i686) ARCH=x86;;
301        i86pc) ARCH=x86;;
302        amd64) ARCH=x86;;
303        ppc64) ARCH=ppc;;
304        *86) ARCH=x86;;
305        *86_64) ARCH=x86;;
306        aarch64) ARCH=arm64;;
307        arm64) ARCH=arm64;;
308        iPhone5*[3-9]) ARCH=arm64;;
309        iPhone[6-9]*) ARCH=arm64;;
310        iPhone[1-9][0-9]*) ARCH=arm64;;
311        iPad[4-9]*) ARCH=arm64;;
312        iPad[1-9][0-9]*) ARCH=arm64;;
313        AppleTV[5-9]*) ARCH=arm64;;
314        AppleTV[1-9][0-9]*) ARCH=arm64;;
315        "Power Macintosh") ARCH=ppc;;
316     esac
317 }
318
319 find_num_cores() {
320     $ECHO "Finding NUM_CORES..."
321     NUM_CORES=1
322     uname_s=$(uname -s)
323     check_ret uname
324     case $uname_s in
325         CYGWIN_NT-5.2-WOW64 | *CYGWIN_NT* | *CYGWIN* | MINGW32*) NUM_CORES=$NUMBER_OF_PROCESSORS;;
326         *linux* | *Linux*) NUM_CORES=$(getconf _NPROCESSORS_ONLN || nproc);;
327         *darwin* | *Darwin* | freebsd) NUM_CORES=$(sysctl -n hw.ncpu);;
328     esac
329 }
330
331 find_word_size() {
332     if [[ -n $WORD ]] ; then return; fi
333     $ECHO "Finding WORD..."
334     WORD=$(getconf LONG_BIT || find_word_size_cpp || find_word_size_c)
335 }
336
337 find_word_size_cpp() {
338     SIXTY_FOUR='defined(__aarch64__) || defined(__x86_64__) || defined(_M_AMD64) || defined(__PPC64__) || defined(__64BIT__)'
339     THIRTY_TWO='defined(i386) || defined(__i386) || defined(__i386__) || defined(_MIX86)'
340     $CC -E -xc <(echo -e "#if ${SIXTY_FOUR}\n64\n#elif ${THIRTY_TWO}\n32\n#endif") | tail -1
341 }
342
343 find_word_size_c() {
344     C_WORD="factor-word-size"
345     TEST_PROGRAM="int main(){ return (long)(8*sizeof(void*)); }"
346     echo $TEST_PROGRAM | $CC -o $C_WORD -xc -
347     check_ret $CC
348     ./$C_WORD
349     WORD_OUT=$?
350     case $WORD_OUT in
351         32) ;;
352         64) ;;
353         *)
354             echo "Word size should be 32/64, got '$WORD_OUT'"
355             exit_script 15;;
356     esac
357     $DELETE -f $C_WORD
358     echo "$WORD_OUT"
359 }
360
361 set_factor_binary() {
362     case $OS in
363         windows) FACTOR_BINARY=factor.com;;
364         *) FACTOR_BINARY=factor;;
365     esac
366 }
367
368 set_factor_library() {
369     case $OS in
370         windows) FACTOR_LIBRARY=factor.dll;;
371         macosx) FACTOR_LIBRARY=libfactor.dylib;;
372         *) FACTOR_LIBRARY=libfactor.a;;
373     esac
374 }
375
376 set_factor_image() {
377     FACTOR_IMAGE=factor.image
378     FACTOR_IMAGE_FRESH=factor.image.fresh
379 }
380
381 echo_build_info() {
382     $ECHO OS=$OS
383     $ECHO ARCH=$ARCH
384     $ECHO NUM_CORES=$NUM_CORES
385     $ECHO WORD=$WORD
386     $ECHO DEBUG=$DEBUG
387     $ECHO REPRODUCIBLE=$REPRODUCIBLE
388     $ECHO CURRENT_BRANCH=$CURRENT_BRANCH
389     $ECHO FACTOR_BINARY=$FACTOR_BINARY
390     $ECHO FACTOR_LIBRARY=$FACTOR_LIBRARY
391     $ECHO FACTOR_IMAGE=$FACTOR_IMAGE
392     $ECHO MAKE_TARGET=$MAKE_TARGET
393     $ECHO BOOT_IMAGE=$BOOT_IMAGE
394     $ECHO MAKE_IMAGE_TARGET=$MAKE_IMAGE_TARGET
395     $ECHO GIT_PROTOCOL=$GIT_PROTOCOL
396     $ECHO GIT_URL=$GIT_URL
397     $ECHO DOWNLOADER=$DOWNLOADER
398     $ECHO CC=$CC
399     $ECHO CXX=$CXX
400     $ECHO MAKE=$MAKE
401     $ECHO COPY=$COPY
402     $ECHO DELETE=$DELETE
403 }
404
405 check_os_arch_word() {
406     if ! [[ -n $OS && -n $ARCH && -n $WORD ]] ; then
407         $ECHO "OS: $OS"
408         $ECHO "ARCH: $ARCH"
409         $ECHO "WORD: $WORD"
410         $ECHO "OS, ARCH, or WORD is empty.  Please report this."
411
412         $ECHO $MAKE_TARGET
413         exit_script 5
414     fi
415 }
416
417 set_build_info() {
418     check_os_arch_word
419     if [[ $OS == linux && $ARCH == ppc ]] ; then
420         MAKE_IMAGE_TARGET=linux-ppc.32
421         MAKE_TARGET=linux-ppc-32
422     elif [[ $OS == linux && $ARCH == arm64 ]] ; then
423         MAKE_IMAGE_TARGET=unix-arm.64
424         MAKE_TARGET=linux-arm-64
425     elif [[ $OS == macosx && $ARCH == arm64 ]] ; then
426         MAKE_IMAGE_TARGET=unix-arm.64
427         MAKE_TARGET=macosx-arm64
428     elif [[ $OS == windows && $ARCH == x86 && $WORD == 64 ]] ; then
429         MAKE_IMAGE_TARGET=windows-x86.64
430         MAKE_TARGET=windows-x86-64
431     elif [[ $OS == windows && $ARCH == x86 && $WORD == 32 ]] ; then
432         MAKE_IMAGE_TARGET=windows-x86.32
433         MAKE_TARGET=windows-x86-32
434     elif [[ $ARCH == x86 && $WORD == 64 ]] ; then
435         MAKE_IMAGE_TARGET=unix-x86.64
436         MAKE_TARGET=$OS-x86-64
437     elif [[ $ARCH == x86 && $WORD == 32 ]] ; then
438         MAKE_IMAGE_TARGET=unix-x86.32
439         MAKE_TARGET=$OS-x86-32
440     else
441         MAKE_IMAGE_TARGET=$ARCH.$WORD
442         MAKE_TARGET=$OS-$ARCH-$WORD
443     fi
444     BOOT_IMAGE=boot.$MAKE_IMAGE_TARGET.image
445 }
446
447 parse_build_info() {
448     ensure_program_installed cut
449     $ECHO "Parsing make target from command line: $1"
450     OS=$(echo $1 | cut -d '-' -f 1)
451     ARCH=$(echo $1 | cut -d '-' -f 2)
452     WORD=$(echo $1 | cut -d '-' -f 3)
453
454     if [[ $OS == linux && $ARCH == ppc ]] ; then WORD=32; fi
455     if [[ $OS == linux && $ARCH == arm ]] ; then WORD=32; fi
456     if [[ $OS == macosx && $ARCH == ppc ]] ; then WORD=32; fi
457
458     $ECHO "OS=$OS"
459     $ECHO "ARCH=$ARCH"
460     $ECHO "WORD=$WORD"
461 }
462
463 find_build_info() {
464     find_os
465     find_architecture
466     find_num_cores
467     set_cc
468     find_word_size
469     set_current_branch
470     set_factor_binary
471     set_factor_library
472     set_factor_image
473     set_build_info
474     set_downloader
475     set_make
476     echo_build_info
477 }
478
479 invoke_git() {
480     git "$@"
481     check_ret git
482 }
483
484 git_clone() {
485     $ECHO "Downloading the git repository from github.com..."
486     invoke_git clone $GIT_URL
487 }
488
489 update_script_name() {
490     $ECHO "$(dirname $0)/_update.sh"
491 }
492
493 update_script() {
494     local -r update_script=$(update_script_name)
495     local -r bash_path=$(which bash)
496     $ECHO "updating from ${CURRENT_BRANCH}"
497     $ECHO "#!$bash_path" >"$update_script"
498     $ECHO "git pull \"$GIT_URL\" ${CURRENT_BRANCH}" >>"$update_script"
499     $ECHO "if [[ \$? -eq 0 ]]; then exec \"$0\" $SCRIPT_ARGS; else echo \"git pull failed\"; exit 2; fi" \
500         >>"$update_script"
501     $ECHO "exit 0" >>"$update_script"
502
503     chmod 755 "$update_script"
504     exec "$update_script"
505 }
506
507 update_script_changed() {
508     invoke_git diff --stat "$(invoke_git merge-base HEAD FETCH_HEAD)" FETCH_HEAD | grep 'build\.sh' >/dev/null
509 }
510
511 git_fetch() {
512     $ECHO "Fetching the git repository from github.com..."
513     set_current_branch
514
515     rm -f "$(update_script_name)"
516     $ECHO git fetch "$GIT_URL" "${CURRENT_BRANCH}"
517     invoke_git fetch "$GIT_URL" "${CURRENT_BRANCH}"
518
519     if update_script_changed; then
520         $ECHO "Updating and restarting the build.sh script..."
521         update_script
522     else
523         $ECHO "Updating the working tree..."
524         invoke_git pull "$GIT_URL" "${CURRENT_BRANCH}"
525     fi
526 }
527
528 cd_factor() {
529     cd "factor"
530     check_ret cd
531 }
532
533 set_copy() {
534     case $OS in
535         windows) COPY=cp;;
536         *) COPY=cp;;
537     esac
538 }
539
540 set_delete() {
541     case $OS in
542         windows) DELETE=rm;;
543         *) DELETE=rm;;
544     esac
545 }
546
547 backup_factor() {
548     $ECHO "Backing up factor..."
549     $COPY $FACTOR_BINARY $FACTOR_BINARY.bak
550     $COPY $FACTOR_LIBRARY $FACTOR_LIBRARY.bak
551     $COPY $BOOT_IMAGE $BOOT_IMAGE.bak
552     $COPY $FACTOR_IMAGE $FACTOR_IMAGE.bak
553     $ECHO "Done with backup."
554 }
555
556 check_makefile_exists() {
557     if [[ ! -e "GNUmakefile" ]] ; then
558         $ECHO ""
559         $ECHO "***GNUmakefile not found***"
560         $ECHO "You are likely in the wrong directory."
561         $ECHO "Run this script from your factor directory:"
562         $ECHO "     ./build.sh"
563         exit_script 6
564     fi
565 }
566
567 invoke_make() {
568     check_makefile_exists
569     $MAKE $MAKE_OPTS "$@"
570     check_ret $MAKE
571 }
572
573 make_clean() {
574     invoke_make clean
575 }
576
577 make_factor() {
578     $ECHO "Building factor with $NUM_CORES cores"
579     invoke_make CC=$CC CXX=$CXX $MAKE_TARGET -j$NUM_CORES
580 }
581
582 make_clean_factor() {
583     make_clean
584     make_factor
585 }
586
587 current_git_branch() {
588     # git rev-parse --abbrev-ref HEAD # outputs HEAD for detached head
589     # outputs nothing for detached HEAD, which is fine for ``git fetch``
590     git describe --all --exact-match 2>/dev/null | sed 's=.*/=='
591 }
592
593 check_url() {
594     if [[ $DOWNLOADER_NAME == 'wget' ]]; then
595         if [[ $(wget -S --spider $1 2>&1 | grep 'HTTP/1.1 200 OK') ]]; then
596             return 0
597         else
598             return 1
599         fi
600     elif [[ $DOWNLOADER_NAME == 'curl' ]]; then
601         local code=$(curl -sL -w "%{http_code}\\n" "$1" -o /dev/null)
602         if [[ $code -eq 200 ]]; then return 0; else return 1; fi
603     else
604         $ECHO "error: wget or curl required in check_url"
605         exit_script 12
606     fi
607 }
608
609 # If we are on a branch, first try to get a boot image for that branch.
610 # Otherwise, just use `master`
611 set_boot_image_vars() {
612     set_current_branch
613     local url="http://downloads.factorcode.org/images/${CURRENT_BRANCH}/checksums.txt"
614     check_url $url
615     if [[ $? -eq 0 ]]; then
616         CHECKSUM_URL="$url"
617         BOOT_IMAGE_URL="http://downloads.factorcode.org/images/${CURRENT_BRANCH}/${BOOT_IMAGE}"
618     else
619         $ECHO "boot image for branch \`${CURRENT_BRANCH}\` is not on server, trying master instead"
620         $ECHO "  tried nonexistent url: ${url}"
621         CHECKSUM_URL="http://downloads.factorcode.org/images/master/checksums.txt"
622         BOOT_IMAGE_URL="http://downloads.factorcode.org/images/master/${BOOT_IMAGE}"
623     fi
624 }
625
626 set_current_branch() {
627     if [ -n "${CI_BRANCH}" ]; then
628         CURRENT_BRANCH="${CI_BRANCH}"
629     else
630         CURRENT_BRANCH=$(current_git_branch)
631     fi
632 }
633
634 update_boot_image() {
635     set_boot_image_vars
636     $ECHO "Deleting old images..."
637     $DELETE checksums.txt* > /dev/null 2>&1
638     # delete boot images with one or two characters after the dot
639     $DELETE $BOOT_IMAGE.{?,??} > /dev/null 2>&1
640     $DELETE temp/staging.*.image > /dev/null 2>&1
641     if [[ -f $BOOT_IMAGE ]] ; then
642         get_url $CHECKSUM_URL
643         local factorcode_md5=$(cat checksums.txt | grep $BOOT_IMAGE | cut -f2 -d' ')
644         set_md5sum
645         local disk_md5=$($MD5SUM $BOOT_IMAGE | cut -f1 -d' ')
646         $ECHO "Factorcode md5: $factorcode_md5";
647         $ECHO "Disk md5: $disk_md5";
648         if [[ "$factorcode_md5" == "$disk_md5" ]] ; then
649             $ECHO "Your disk boot image matches the one on downloads.factorcode.org."
650         else
651             $DELETE $BOOT_IMAGE > /dev/null 2>&1
652             get_boot_image
653         fi
654     else
655         get_boot_image
656     fi
657 }
658
659 get_boot_image() {
660     $ECHO "Downloading boot image $BOOT_IMAGE."
661     get_url "${BOOT_IMAGE_URL}"
662 }
663
664 get_url() {
665     if [[ -z $DOWNLOADER ]] ; then
666         set_downloader;
667     fi
668     $ECHO $DOWNLOADER $1 ;
669     $DOWNLOADER $1
670     check_ret $DOWNLOADER
671 }
672
673 get_config_info() {
674     find_build_info
675     check_installed_programs
676     check_libraries
677 }
678
679 copy_fresh_image() {
680     $ECHO "Copying $FACTOR_IMAGE to $FACTOR_IMAGE_FRESH..."
681     $COPY $FACTOR_IMAGE $FACTOR_IMAGE_FRESH
682 }
683
684 bootstrap() {
685     ./$FACTOR_BINARY -i=$BOOT_IMAGE
686     check_ret "./$FACTOR_BINARY bootstrap failed"
687     copy_fresh_image
688 }
689
690 install() {
691     check_factor_exists
692     get_config_info
693     git_clone
694     cd_factor
695     make_factor
696     set_boot_image_vars
697     get_boot_image
698     bootstrap
699 }
700
701 update() {
702     get_config_info
703     git_fetch
704     backup_factor
705     make_clean_factor
706 }
707
708 download_and_bootstrap() {
709     update_boot_image
710     bootstrap
711 }
712
713 net_bootstrap_no_pull() {
714     get_config_info
715     make_clean_factor
716     download_and_bootstrap
717 }
718
719 refresh_image() {
720     ./$FACTOR_BINARY -e="USING: vocabs.loader vocabs.refresh system memory ; refresh-all save 0 exit"
721     check_ret factor
722 }
723
724 make_boot_image() {
725     ./$FACTOR_BINARY -run="bootstrap.image" "$MAKE_IMAGE_TARGET"
726     check_ret factor
727 }
728
729 install_deps_apt() {
730     sudo apt install --yes libc6-dev libpango1.0-dev libx11-dev xorg-dev libgtk2.0-dev gtk2-engines-pixbuf libgtkglext1-dev wget git git-doc rlwrap clang make screen tmux libssl-dev
731     check_ret sudo
732 }
733
734 install_deps_pacman() {
735     sudo pacman --noconfirm -Syu gcc clang make rlwrap git wget pango glibc gtk2 gtk3 gtkglext gtk-engines gdk-pixbuf2 libx11 screen tmux
736     check_ret sudo
737 }
738
739 install_deps_dnf() {
740     sudo dnf --assumeyes install gcc gcc-c++ glibc-devel binutils libX11-devel pango-devel gtk3-devel gdk-pixbuf2-devel gtkglext-devel tmux rlwrap wget
741     check_ret sudo
742 }
743
744 install_deps_pkg() {
745     sudo pkg install --yes git gmake gcc rlwrap ripgrep curl gmake x11-toolkits/gtk30 x11-toolkits/gtkglext pango cairo vim
746 }
747
748
749 install_deps_macosx() {
750     test_program_installed git
751     if [[ $? -ne 1 ]] ; then
752         ensure_program_installed yes
753         $ECHO "git not found."
754         $ECHO "This script requires either git-core or port."
755         $ECHO "If it fails, install git-core or port and try again."
756         ensure_program_installed port
757         $ECHO "Installing git-core with port...this will take awhile."
758         yes | sudo port install git-core
759     fi
760 }
761
762 usage() {
763     $ECHO "usage: $0 command [optional-target]"
764     $ECHO "  install - git clone, compile, bootstrap"
765     $ECHO "  deps-apt - install required packages for Factor on Linux using apt"
766     $ECHO "  deps-pacman - install required packages for Factor on Linux using pacman"
767     $ECHO "  deps-dnf - install required packages for Factor on Linux using dnf"
768     $ECHO "  deps-pkg - install required packages for Factor on FreeBSD using pkg"
769     $ECHO "  deps-macosx - install git on MacOSX using port"
770     $ECHO "  self-update - git pull, recompile, make local boot image, bootstrap"
771     $ECHO "  quick-update - git pull, refresh-all, save"
772     $ECHO "  update|latest - git pull, recompile, download a boot image, bootstrap"
773     $ECHO "  compile - compile the binary"
774     $ECHO "  recompile - recompile the binary"
775     $ECHO "  bootstrap - bootstrap with existing boot image"
776     $ECHO "  net-bootstrap - recompile, download a boot image, bootstrap"
777     $ECHO "  make-target - find and print the os-arch-cpu string"
778     $ECHO "  report|info - print the build variables"
779     $ECHO "  update-boot-image - get the boot image for the current branch"
780     $ECHO ""
781     $ECHO "If you are behind a firewall, invoke as:"
782     $ECHO "env GIT_PROTOCOL=http $0 <command>"
783     $ECHO ""
784     $ECHO "Example for overriding the default target:"
785     $ECHO "    $0 update macosx-x86-32"
786 }
787
788 MAKE_TARGET=unknown
789
790 # -n is nonzero length, -z is zero length
791 if [[ -n "$2" ]] ; then
792     parse_build_info $2
793 fi
794
795 if [ "$#" -gt 3 ]; then
796     usage
797     $ECHO "error: too many arguments"
798     exit 1
799 fi
800
801
802 set_copy
803 set_delete
804
805 case "$1" in
806     install) install ;;
807     deps-apt) install_deps_apt ;;
808     deps-pacman) install_deps_pacman ;;
809     deps-macosx) install_deps_macosx ;;
810     deps-dnf) install_deps_dnf ;;
811     deps-pkg) install_deps_pkg ;;
812     self-bootstrap) get_config_info; make_boot_image; bootstrap;;
813     self-update) update; make_boot_image; bootstrap;;
814     quick-update) update; refresh_image ;;
815     update|latest) update; download_and_bootstrap ;;
816     compile) find_build_info; make_factor ;;
817     recompile) find_build_info; make_clean; make_factor ;;
818     bootstrap) get_config_info; bootstrap ;;
819     net-bootstrap) net_bootstrap_no_pull ;;
820     make-target) FIND_MAKE_TARGET=true; ECHO=false; find_build_info; exit_script ;;
821     report|info) find_build_info ;;
822     full-report) find_build_info; check_installed_programs; check_libraries ;;
823     update-boot-image) find_build_info; check_installed_programs; update_boot_image;;
824     *) usage ;;
825 esac
826